# STM32F3348-DISCO Discovery board

## Overview

The 32F3348DISCOVERY Discovery kit (order code STM32F3348-DISCO) helps the user discover the full range of features of the STM32F334 line and develop applications. It is based on STM32F334C8T6 and includes ST-LINK/V2-1 embedded debug tool interface, high-brightness LED dimming with buck converter, buck-boost converter, LEDs, an push-buttons.

ST-LINK/V2-1 is integrated into the board, as the embedded in-circuit debugger and programmer.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1735--discovery-kit-with-stm32f334c8-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32F334C8 microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32f334c8.html)
- [STM32F3348-DISCO board](https://www.st.com/en/evaluation-tools/32f3348discovery.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1735--discovery-kit-with-stm32f334c8-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/32f3348discovery.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1142-f334-b01-schematic.pdf)
